<mat-card>
  <mat-card-actions align="end" class="mr-0 mb-0 p-10">
    <button mat-flat-button color="primary" routerLink="create">{{'participants.actions.create' | translate}}</button>
  </mat-card-actions>
  <mat-card-content *ngIf="dataAvailable">
    <mat-expansion-panel [expanded]="false" (keyup.enter)="applyFilter()">
      <mat-expansion-panel-header>
        <mat-panel-title>
          {{'filterPanel.title' | translate}}
        </mat-panel-title>
      </mat-expansion-panel-header>

      <div class="row">
        <mat-form-field class="col" style="width: 100%">
          <input [(ngModel)]="codeFilter" matInput placeholder="{{'participants.filters.code' | translate}}"
                 type="text">
        </mat-form-field>
        <mat-form-field class="col" style="width: 100%">
          <input [(ngModel)]="bicFilter" matInput placeholder="{{'participants.filters.bic' | translate}}" type="text">
        </mat-form-field>
      </div>
      <div class="row">
        <mat-form-field class="col" style="width: 100%">
          <input [(ngModel)]="nameFilter" matInput placeholder="{{'participants.filters.name' | translate}}"
                 type="text">
        </mat-form-field>
        <mat-form-field class="col" style="width: 100%">
          <mat-select placeholder="{{'participants.filters.participantType' | translate}}"
                      [(ngModel)]="participantTypeFilter">
            <mat-option>NONE</mat-option>
            <mat-option *ngFor="let selectItem of participantTypes" [value]="selectItem">
              {{selectItem}}
            </mat-option>
          </mat-select>
        </mat-form-field>
      </div>

      <mat-action-row>
        <button mat-button color="warn" (click)="resetDefaults()">{{'filterPanel.resetButton' | translate}}</button>
        <button mat-button color="primary" (click)="applyFilter()">{{'filterPanel.applyButton' | translate}}</button>
      </mat-action-row>
    </mat-expansion-panel>

    <div class="table-responsive">
      <table mat-table [dataSource]="dataSource" matSort matSortDisableClear (matSortChange)="onSortChange($event)"
             class="table mat-elevation-z4" [matSortActive]="pageRequest.sortBy[0]"
             [matSortDirection]="pageRequest.sortDirection">

        <ng-container matColumnDef="code">
          <th mat-header-cell *matHeaderCellDef mat-sort-header>{{'participants.labels.code' | translate}}</th>
          <td mat-cell *matCellDef="let element"><a routerLink="{{element.code}}">{{element.code}}</a></td>
        </ng-container>
        <ng-container matColumnDef="bic">
          <th mat-header-cell *matHeaderCellDef mat-sort-header>{{'participants.labels.bic' | translate}}</th>
          <td mat-cell *matCellDef="let element">{{getDefaultValueIfNull(element.bic)}}</td>
        </ng-container>
        <ng-container class="mat-dialog-content" matColumnDef="name">
          <th mat-header-cell *matHeaderCellDef mat-sort-header>{{'participants.labels.name' | translate}}</th>
          <td mat-cell *matCellDef="let element">{{element.name}}</td>
        </ng-container>
        <ng-container class="mat-dialog-content" matColumnDef="participantType">
          <th mat-header-cell *matHeaderCellDef mat-sort-header>{{'participants.labels.participantType' | translate}}</th>
          <td mat-cell *matCellDef="let element">{{element.participantType}}</td>
        </ng-container>

        <tr mat-header-row *matHeaderRowDef="['code','bic','name','participantType']"></tr>
        <tr mat-row *matRowDef="let row; columns: ['code','bic','name','participantType'];"></tr>
      </table>
    </div>
    <app-no-records-found [dataAvailable]="dataAvailable"
                          [dataLength]="dataSource?.data?.length"></app-no-records-found>

    <mat-paginator id="pagingToolbar" #paginator [showFirstLastButtons]="true" [pageIndex]="pageInfo.number"
                   [length]="pageInfo.totalElements" [pageSize]="pageInfo.size" [pageSizeOptions]="[5, 10, 20, 40]"
                   (page)="onPageEvent($event)">
    </mat-paginator>
  </mat-card-content>
</mat-card>
